package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.WFUserGroupService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.WFUserGroup;
import com.sa.ibiz.demo.demo.service.dto.WFUserGroupSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/wfusergroup")
public class WFUserGroupController{



    @Autowired
	private WFUserGroupService wfusergroupService;
	/**
	 * 获取服务对象
	*/
	protected WFUserGroupService getService(){
		return this.wfusergroupService;
	}



	@PostMapping(value="jqmaineditform/update")
	public ResponseEntity<WFUserGroup_EditForm_JQMain> jQMainEditFormUpdate(@Validated @RequestBody WFUserGroup_EditForm_JQMain form){
            WFUserGroup entity =form.toWFUserGroup();
            getService().update(entity);
            form.fromWFUserGroup(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="jqmaineditform/remove")
	public ResponseEntity<WFUserGroup_EditForm_JQMain> jQMainEditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            WFUserGroup_EditForm_JQMain form=new WFUserGroup_EditForm_JQMain();
            WFUserGroup entity = new WFUserGroup();
            entity.setWfusergroupid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromWFUserGroup(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="jqmaineditform/getdraft")
	public ResponseEntity<WFUserGroup_EditForm_JQMain> jQMainEditFormGetDraft(@RequestBody WFUserGroup_EditForm_JQMain form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            WFUserGroup sourceEntity =new WFUserGroup();
            sourceEntity.setWfusergroupid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			WFUserGroup targetEntity =new WFUserGroup();
			sourceEntity.copyTo(targetEntity);
			form.fromWFUserGroup(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            WFUserGroup entity =form.toWFUserGroup();
            getService().getDraft(entity);
            form.fromWFUserGroup(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="jqmaineditform/get")
	public ResponseEntity<WFUserGroup_EditForm_JQMain> jQMainEditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            WFUserGroup_EditForm_JQMain form=new WFUserGroup_EditForm_JQMain();
            WFUserGroup entity = new WFUserGroup();
            entity.setWfusergroupid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromWFUserGroup(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="jqmaineditform/create")
	public ResponseEntity<WFUserGroup_EditForm_JQMain> jQMainEditFormCreate(@Validated @RequestBody WFUserGroup_EditForm_JQMain form){
            WFUserGroup entity =form.toWFUserGroup();
            getService().create(entity);
            form.fromWFUserGroup(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maingrid/update")
	public WFUserGroup mainGridUpdate(@Validated WFUserGroup mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/remove")
	public ResponseEntity<WFUserGroup> mainGridRemove(@Validated @RequestBody Map args){
	    WFUserGroup entity =new WFUserGroup();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setWfusergroupid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public WFUserGroup mainGridGet(String wfusergroupid){
		return null;
	}
	@PostMapping(value="maingrid/getdraft")
	public WFUserGroup mainGridGetDraft(@Validated WFUserGroup mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/create")
	public WFUserGroup mainGridCreate(@Validated WFUserGroup mainItem){
		return mainItem;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="maingrid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> maingridExportDataSearchDefault(@Validated @RequestBody WFUserGroupSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<WFUserGroup> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=WFUserGroup_Grid_Main.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=WFUserGroup_Grid_Main.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=WFUserGroup_Grid_Main.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="maingrid/searchdefault")
	public ResponseEntity<Page<WFUserGroup_Grid_Main>> mainGridSearchDefault(@Validated @RequestBody WFUserGroupSearchFilter searchFilter){
			Page<WFUserGroup> searchResult = this.getService().searchDefault(searchFilter);
			Page<WFUserGroup_Grid_Main> searchResult_vo_data =WFUserGroup_Grid_Main.fromWFUserGroup(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<WFUserGroup_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody WFUserGroup_SearchForm_Default searchform){
 		 
			WFUserGroupSearchFilter searchfilter =searchform.toWFUserGroupSearchFilter();
			searchform.fromWFUserGroupSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }